//     A simple hack to display an image in a separate window

#include "image.h"

class RGB32Pixel
{
  unsigned char B, G, R, A;
public:
  RGB32Pixel(const GRAY gray)
   : B(gray), G(gray), R(gray), A(0) {}
  void operator = (const GRAY gray)
  { B = G = R = gray; A = 0; }
};

class ScreenRect : public BRect
{
public:
  ScreenRect(const BRect& rect) : BRect(rect) {}
  ScreenRect(const IMAGE& image);
//  ScreenRect(const rowcol& heightwidth);
					// Create a rectangle of given height/width
					// positioned at a given point
//  ScreenRect(const rowcol& origin, const rowcol& heightwidth);
  ScreenRect& operator += (const int offset);
  operator BRect  (void) 				{ return *this; }
  int q_width(void)  const              { return right >= left ? right - left : left - right; }
  int q_height(void) const              { return bottom >= top ? bottom - top : top - bottom; }
                                // Give a STATIC string representation of
                                // the rectangle
//  operator const char * (void) const;
	// shift be to window coordinate system
  void offset_to_origin(void)  { OffsetTo(B_ORIGIN); }
  void print(const char * title = "") const;
};


class MyImageView : public BView, public BBitmap
{
public:
   MyImageView(const IMAGE& image);     
   void Draw(BRect rect)
    { DrawBitmap(this,BPoint(0,0)); }
};

class WindowDestroyer
{
 BWindow * windows_made;
// static WindowDestroyer me;  // The only instance of this class
 							// ever can be made
 							// And this private constructor will
 							// see to it...
 					// Copy-constructors are forbidden
 WindowDestroyer(const WindowDestroyer&);
 void operator = (const WindowDestroyer&);
 void kill_it(void)
 { if( windows_made )
    windows_made->Quit(), windows_made = 0;
 }
public:
 WindowDestroyer(void) : windows_made (0) {}
 void add(BWindow * window_ptr)
   { kill_it(); windows_made = window_ptr; }
  ~WindowDestroyer(void) { kill_it(); }
};

class MyImageWindow : public BWindow
{
public:
   MyImageWindow(const IMAGE& image, const char * title)
   : BWindow((ScreenRect)image,title,B_TITLED_WINDOW,
   	B_NOT_CLOSABLE)
   	{
   	  MoveBy(5,0);
   	  Show();
   	  AddChild(new MyImageView(image));
   	}
};
